<?php
namespace Ecommerce\Controllers;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;

class FornecedoresLogin extends \Teknisa\Libs\Controller\CRUD
{
    protected $dataSourceName = 'fornecedoresLogin';
    protected $parameterBagColumns = array(
        "DSLOGINECO"
    );

    protected $dataSourceManager;
    protected $fornecedor;

    public function __construct($crudService, $parameterBag, $dataSourceManager, $fornecedor) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->dataSourceManager = $dataSourceManager;
        $this->fornecedor = $fornecedor;
    }

    public function find(Request\Filter $request, Response $response) {
        try {
            $filterCriteria = $request->getFilterCriteria();
            $filterCriteria->setDataSourceName($this->dataSourceName);
            $newFilterCriteria = $this->crudService->getPopulatedFilterCriteria($filterCriteria, $this->parameterBagColumns);
            $dataSource = $this->dataSourceManager->findBy($newFilterCriteria);
            $dataSet = self::montaDataSet($dataSource->getRows());
            $dataSet = $this->fornecedor->formataMascara($dataSet, $this->fornecedor->getObjectProviderType());
            $response->addDataSet(new DataSet('fornecedoresLogin', $dataSet));
        } catch (\Exception $e) {
            $response->setError(new Response\Error("Error in data save. ". $e->getMessage(), 500));
        }
    }

    public function montaDataSet(array $rows) {
        $dataSet = array();

        foreach($rows as $row){
            if(is_null($row['REGISTROPAI'])){
                $row['_hasChild'] = true;
            } else{
                $row['_hasChild'] = false;
            }
            array_push($dataSet, $row);
        }

        return $dataSet;
    }

}