/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_IEST                                                     */
/* Tabela : INSCRESTAD                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 18/06/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_IEST
BEFORE INSERT OR UPDATE OR DELETE
ON INSCRESTAD FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUIEST := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDINSCESTA,0)   <> NVL(:NEW.CDINSCESTA,0))   OR
         (NVL(:OLD.NMREPRINSEST,0) <> NVL(:NEW.NMREPRINSEST,0)) OR
         (NVL(:OLD.IDTPIJURIEST,0) <> NVL(:NEW.IDTPIJURIEST,0)) OR
         (NVL(:OLD.NRINSJURIEST,0) <> NVL(:NEW.NRINSJURIEST,0)) OR
         (NVL(:OLD.SGESTADO,0)     <> NVL(:NEW.SGESTADO,0))     OR
         (NVL(:OLD.NRCEPIEST,0)    <> NVL(:NEW.NRCEPIEST,0))    OR
         (NVL(:OLD.DSENDEIEST,0)   <> NVL(:NEW.DSENDEIEST,0))   OR
         (NVL(:OLD.NMBAIRIEST,0)   <> NVL(:NEW.NMBAIRIEST,0))   OR
         (NVL(:OLD.NRTELEIEST,0)   <> NVL(:NEW.NRTELEIEST,0))   OR
         (NVL(:OLD.NRFAXIEST,0)    <> NVL(:NEW.NRFAXIEST,0))    OR
         (NVL(:OLD.CDPAIS,0)       <> NVL(:NEW.CDPAIS,0))       OR
         (NVL(:OLD.CDMUNICIPIO,0)  <> NVL(:NEW.CDMUNICIPIO,0))  OR
         (NVL(:OLD.CDEMPRESA,0)    <> NVL(:NEW.CDEMPRESA,0))    OR
         (NVL(:OLD.IDTPAMBIENTENFE, 0) <> NVL(:NEW.IDTPAMBIENTENFE, 0)) OR
         (NVL(:OLD.NRSERIECERTIFIC, 0) <> NVL(:NEW.NRSERIECERTIFIC, 0)) OR
         (:OLD.DTINIVIGIEST) <> (:NEW.DTINIVIGIEST) OR
         (:OLD.DTFIMVIGIEST) <> (:NEW.DTFIMVIGIEST)
         THEN
         :NEW.DTULTATUIEST := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('INSCRESTAD', '', 'CDEMPRESA='||:OLD.CDEMPRESA||';CDINSCESTA='||:OLD.CDINSCESTA||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE INSCRESTAD MODIFY DTULTATUIEST DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_IEST','5.05.012'); END;
/

