/* Tecnisa - Tecnologia em Informtica

 Nome: 0400_CUSFUN_CUSTO_GLOBAL

 Descrio:
 Funo para clculo do custo do produto de acordo com a tabela TIPOCUSTO
_________________________________________________________________________
_________________________________________________________________________
   01 Custo Mdio Lquido Atual
   02 Custo Mdio Bruto Atual
   03 Custo Mdio Lquido da poca
   04 Custo Mdio Bruto da poca
   05 Custo da ltima Compra (NF)
   06 Custo de Cotao (Lista de Preos)
   07 Custo da ltima compra(AF)
   20 Custo Mdio Lquido Atual
   21 Custo Mdio Lquido Atual
   22 Custo Mdio Bruto Atual
   23 Custo Mdio Bruto Atual
   24 Custo Mdio Lquido da poca
   25 Custo Mdio Lquido da poca
   26 Custo Mdio Bruto da poca
   27 Custo Mdio Bruto da poca
   28 Custo da ltima Compra (NF)
   29 Custo da ltima Compra (NF)
   30 Custo de Cotao (Lista de Preos)
   31 Custo de Cotao (Lista de Preos)
   32 Custo da ltima Compra(AF)
   33 Custo da ltima Compra(AF)
   34 Custo Mdio Atualizado
   35 Custo Mdio Atualizado
_________________________________________________________________________
_________________________________________________________________________

 Criao:
 13/10/2003 - Roberto A. Lopes Martins

 @C:\Win_V4\Sql\End_Conv\Oracle\0400_CUSFUNO.SQL
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'CUSTO_GLOBAL' AND
                 TYPE = 'FN' 		       AND
	              U.UID = O.UID            AND
	              U.NAME = USER)
DROP FUNCTION CUSTO_GLOBAL
GO
CREATE FUNCTION CUSTO_GLOBAL(
   @P_CDPRODUTO    VARCHAR(10),
   @P_NRTIPOCUSTO  INT,
   @P_DTREFERENCIA DATETIME,
   @P_DTATUAL      DATETIME) RETURNS NUMERIC(10,5)
AS
BEGIN
   DECLARE @V_VRCUSTO        NUMERIC(10,5);
   DECLARE @V_DTREFERENCIA   DATETIME;

   DECLARE @V_QTESTDIACON    DOUBLE PRECISION;
   DECLARE @V_QTESTANTCON    DOUBLE PRECISION;
   DECLARE @V_VRESTDIACON    DOUBLE PRECISION;
   DECLARE @V_VRESTDIACOM1   DOUBLE PRECISION;
   DECLARE @V_VRESTDIACOM2   DOUBLE PRECISION;
   DECLARE @V_VRESTANTCON    DOUBLE PRECISION;
   DECLARE @V_VRESTANTCOM1   DOUBLE PRECISION;
   DECLARE @V_VRESTANTCOM2   DOUBLE PRECISION;
   DECLARE @V_VRESTBRUTCON   DOUBLE PRECISION;
   DECLARE @V_VRESTBRUTCM1   DOUBLE PRECISION;
   DECLARE @V_VRESTBRUTCM2   DOUBLE PRECISION;
   DECLARE @V_VRBRUTANTCON   DOUBLE PRECISION;
   DECLARE @V_VRBRUTANTCM1   DOUBLE PRECISION;
   DECLARE @V_VRBRUTANTCM2   DOUBLE PRECISION;

   DECLARE @V_VRULTCOMPR     DOUBLE PRECISION;
   DECLARE @V_VRULTCOMPRM1   DOUBLE PRECISION;
   DECLARE @V_VRULTCOMPRM2   DOUBLE PRECISION;

   DECLARE @V_VRCUSPRLISTP   DOUBLE PRECISION;
   DECLARE @V_VRCUSPRLISM1   DOUBLE PRECISION;
   DECLARE @V_VRCUSPRLISM2   DOUBLE PRECISION;
   DECLARE @V_VRPRCUSTOAF    DOUBLE PRECISION;
   DECLARE @V_VRPRCUSAFM1    DOUBLE PRECISION;
   DECLARE @V_VRPRCUSAFM2    DOUBLE PRECISION;

   DECLARE @V_IDUTILDTPROC   VARCHAR(1);

   SET @V_QTESTDIACON  = 0;
   SET @V_QTESTANTCON  = 0;
   SET @V_VRESTDIACON  = 0;
   SET @V_VRESTDIACOM1 = 0;
   SET @V_VRESTDIACOM2 = 0;
   SET @V_VRESTANTCON  = 0;
   SET @V_VRESTANTCOM1 = 0;
   SET @V_VRESTANTCOM2 = 0;
   SET @V_VRESTBRUTCON = 0;
   SET @V_VRESTBRUTCM1 = 0;
   SET @V_VRESTBRUTCM2 = 0;
   SET @V_VRBRUTANTCON = 0;
   SET @V_VRBRUTANTCM1 = 0;
   SET @V_VRBRUTANTCM2 = 0;

   SET @V_VRCUSTO = 0;

   IF @P_NRTIPOCUSTO IN (1,2,3,4,20,21,22,23,24,25,26,27) BEGIN /*Custos que tem valores na tabela POSESTCONS*/

      SET @V_DTREFERENCIA = @P_DTREFERENCIA;                 /*Custo Mdio da poca*/

      SELECT @V_QTESTDIACON  = ISNULL(SUM(QTESTDIACON),0),
             @V_QTESTANTCON  = ISNULL(SUM(QTESTANTCON),0),
             @V_VRESTDIACON  = ISNULL(SUM(VRESTDIACON),0),
             @V_VRESTDIACOM1 = ISNULL(SUM(VRESTDIACOM1),0),
             @V_VRESTDIACOM2 = ISNULL(SUM(VRESTDIACOM2),0),
             @V_VRESTANTCON  = ISNULL(SUM(VRESTANTCON),0),
             @V_VRESTANTCOM1 = ISNULL(SUM(VRESTANTCOM1),0),
             @V_VRESTANTCOM2 = ISNULL(SUM(VRESTANTCOM2),0),
             @V_VRESTBRUTCON = ISNULL(SUM(VRESTBRUTCON),0),
             @V_VRESTBRUTCM1 = ISNULL(SUM(VRESTBRUTCM1),0),
             @V_VRESTBRUTCM2 = ISNULL(SUM(VRESTBRUTCM2),0),
             @V_VRBRUTANTCON = ISNULL(SUM(VRBRUTANTCON),0),
             @V_VRBRUTANTCM1 = ISNULL(SUM(VRBRUTANTCM1),0),
             @V_VRBRUTANTCM2 = ISNULL(SUM(VRBRUTANTCM2),0)
      FROM POSESTCONS P
      WHERE CDPRODUTO   = @P_CDPRODUTO AND
            DTPOSESTCON = (SELECT MAX(DTPOSESTCON)
                           FROM POSESTCONS PD
                           WHERE CDPRODUTO  = @P_CDPRODUTO   AND
                                 P.CDFILIAL = PD.CDFILIAL   AND
                                 DTPOSESTCON <= (@V_DTREFERENCIA+1));
      IF (@V_QTESTDIACON <> 0) BEGIN
         SET @V_VRESTDIACON  = (@V_VRESTDIACON/@V_QTESTDIACON);
         SET @V_VRESTDIACOM1 = (@V_VRESTDIACOM1/@V_QTESTDIACON);
         SET @V_VRESTDIACOM2 = (@V_VRESTDIACOM2/@V_QTESTDIACON);
         SET @V_VRESTBRUTCON = (@V_VRESTBRUTCON/@V_QTESTDIACON);
         SET @V_VRESTBRUTCM1 = (@V_VRESTBRUTCM1/@V_QTESTDIACON);
         SET @V_VRESTBRUTCM2 = (@V_VRESTBRUTCM2/@V_QTESTDIACON);
      END
      ELSE BEGIN
         IF (@V_QTESTANTCON <> 0) BEGIN
            SET @V_VRESTDIACON  = (@V_VRESTANTCON/@V_QTESTANTCON);
            SET @V_VRESTDIACOM1 = (@V_VRESTANTCOM1/@V_QTESTANTCON);
            SET @V_VRESTDIACOM2 = (@V_VRESTANTCOM2/@V_QTESTANTCON);
            SET @V_VRESTBRUTCON = (@V_VRBRUTANTCON/@V_QTESTANTCON);
            SET @V_VRESTBRUTCM1 = (@V_VRBRUTANTCM1/@V_QTESTANTCON);
            SET @V_VRESTBRUTCM2 = (@V_VRBRUTANTCM2/@V_QTESTANTCON);
         END
         ELSE BEGIN
            SET @V_VRESTDIACON  = 0;
            SET @V_VRESTDIACOM1 = 0;
            SET @V_VRESTDIACOM2 = 0;
            SET @V_VRESTBRUTCON = 0;
            SET @V_VRESTBRUTCM1 = 0;
            SET @V_VRESTBRUTCM2 = 0;
         END;
      END;

      IF (@P_NRTIPOCUSTO IN (1,3)) BEGIN      /*Custo Mdio Lquido*/
         SET @V_VRCUSTO = @V_VRESTDIACON;
      END
      ELSE BEGIN
         IF (@P_NRTIPOCUSTO IN (2,4)) BEGIN   /*Custo Mdio Bruto*/
            SET @V_VRCUSTO = @V_VRESTBRUTCON;
         END
         ELSE BEGIN
            IF (@P_NRTIPOCUSTO IN (20,24)) BEGIN /*Custo Mdio Lquido (ndice 01)*/
               SET @V_VRCUSTO = @V_VRESTDIACOM1;
            END
            ELSE BEGIN
               IF (@P_NRTIPOCUSTO IN (21,25)) BEGIN /*Custo Mdio Lquido (ndice 02)*/
                  SET @V_VRCUSTO = @V_VRESTDIACOM2;
               END
               ELSE BEGIN
                  IF(@P_NRTIPOCUSTO IN (22,26)) BEGIN /*Custo Mdio Bruto (ndice 01)*/
                     SET @V_VRCUSTO = @V_VRESTBRUTCM1;
                  END
                  ELSE BEGIN
                    IF(@P_NRTIPOCUSTO IN (23,27)) BEGIN /*Custo Mdio Bruto (ndice 02)*/
                       SET @V_VRCUSTO = @V_VRESTBRUTCM2;
                    END;
                  END;
               END;
            END;
         END;
      END;
      IF (@P_NRTIPOCUSTO = 6) BEGIN           /*Custo de Cotao (Lista de Preos)*/
         SET @V_VRCUSTO = @V_VRCUSPRLISTP;
      END
      ELSE BEGIN
         IF (@P_NRTIPOCUSTO = 7) BEGIN        /*Custo da ltima compra(AF)*/
            SET @V_VRCUSTO = @V_VRPRCUSTOAF;
         END
         ELSE BEGIN
            IF (@P_NRTIPOCUSTO = 30) BEGIN       /*Custo de Cotao (Lista de Preos) (ndice 01)*/
               SET @V_VRCUSTO = @V_VRCUSPRLISM1;
            END
            ELSE BEGIN
               IF(@P_NRTIPOCUSTO = 31) BEGIN       /*Custo de Cotao (Lista de Preos) (ndice 02)*/
                  SET @V_VRCUSTO = @V_VRCUSPRLISM2;
               END
               ELSE BEGIN
                  IF(@P_NRTIPOCUSTO = 32) BEGIN       /*Custo da ltima Compra(AF) (ndice 01)*/
                     SET @V_VRCUSTO = @V_VRPRCUSAFM1;
                  END
                  ELSE BEGIN
                     IF(@P_NRTIPOCUSTO = 33) BEGIN       /*Custo da ltima Compra(AF) (ndice 02)*/
                        SET @V_VRCUSTO = @V_VRPRCUSAFM2;
                     END;
                  END;
               END;
            END;
         END;
      END;
   END;
   RETURN(@V_VRCUSTO);
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'CUSTO_GLOBAL','4.05.109';
GO

