var PedidoCotacaoService = function(restEngine, localStorageEngine, General) {

	this.retornarPedidoCotacao = function(cdforneced, dtExpInicial, dtExpFinal, dtValIni, dtValFin, dtTodasVal, stStatus, stPedExpirado, stTodos) {

		return restEngine.post('/pedidoCotacao', {
			"requestType": "FilterData",
			"filter": [
				 {
				 	"name": "P_CDFORNECED",
				 	"operator": "=",
				 	"value":  cdforneced
				 },
				 {
				 	"name": "P_DTINICIAL",
				 	"operator": "=",
				 	"value":  dtExpInicial
				 },
				 {
				 	"name": "P_DTFINAL",
				 	"operator": "=",
				 	"value":  dtExpFinal
				 },
				 {
					"name": "P_DTVALINI",
				 	"operator": "=",
				 	"value":  dtValIni
				 },
				 {
				 	"name": "P_DTVALFIN",
				 	"operator": "=",
				 	"value":  dtValFin
				 },
				 {
				 	"name": "P_TDTVALIDADE",
				 	"operator": "=",
				 	"value" : dtTodasVal

				 },
				 {
				 	"name": "P_STPEDCOLETA",
				 	"operator": "=",
				 	"value":  stStatus
				 },
				 {
				 	"name": "P_TEXPIRADAS",
				 	"operator": "=",
				 	"value":  stPedExpirado
				 },
				 {
				 	"name": "P_TODOS",
				 	"operator": "=",
				 	"value":  stTodos
				 },
				 {
				 	"name": "NRORG",
				 	"operator": "=",
				 	"value":  getLocalVar('NRORGTRAB')
				 }
			]
		});
	};

	this.retornaProdutoCotacao = function(cdforneced, cdfilial, nrpedidocol) {

		return restEngine.post('/produtoCotacao', {
			"requestType": "FilterData",
			"filter": [
				 {
				 	"name": "P_CDFORNECED",
				 	"operator": "=",
				 	"value":  cdforneced
				 },
				 {
				 	"name": "P_CDFILIAL",
				 	"operator": "=",
				 	"value":  cdfilial
				 },
				 {
				 	"name": "P_NRPEDIDOCOL",
				 	"operator": "=",
				 	"value":  nrpedidocol
				 },
				 {
				 	"name": "NRORG",
				 	"operator": "=",
				 	"value":  getLocalVar('NRORGTRAB')
				 }
			]
		});
	};
	
	this.retornaRegiao = function(cdfilial, nrpedidocol) {

		return restEngine.post('/regiaoCotacao', {
			"requestType": "FilterData",
			"filter": [
				 {
				 	"name": "P_CDFILIAL",
				 	"operator": "=",
				 	"value":  cdfilial
				 },
				 {
				 	"name": "P_NRPEDIDOCOL",
				 	"operator": "=",
				 	"value":  nrpedidocol
				 },
				 {
				 	"name": "NRORG",
				 	"operator": "=",
				 	"value":  getLocalVar('NRORGTRAB')
				 }
			]
		});
	};

	this.validaItemZero = function(cdfilial, nrpedidocol) {

		return restEngine.post('/itemZero', {
			"requestType": "FilterData",
			"filter": [
				 {
				 	"name": "CDFILIAL",
				 	"operator": "=",
				 	"value":  cdfilial
				 },
				 {
				 	"name": "NRPEDIDOCOL",
				 	"operator": "=",
				 	"value":  nrpedidocol
				 },
				 {
				 	"name": "NRORG",
				 	"operator": "=",
				 	"value":  getLocalVar('NRORGTRAB')
				 }
			]
		});
	};
	
	this.recusarCotacao = function(cdfilial, nrpedidocol, idsitupedcoleta) {

		return restEngine.post('/pedcolgeral/save', {
            "requestType": "Row",
    		"row": {
                "NRPEDIDOCOL": nrpedidocol,
                "CDFILIAL": cdfilial,
                "IDSITUPEDCOLETA": idsitupedcoleta, 
                "changed": true,
				"__is_new": false
            }
        });
	};

	this.copiarPreco = function(prodCot) {
		
		var arrayProd = [];

		for(var i in prodCot) {

			var obj = {
				CDFILIAL: prodCot[i].CDFILIAL,
				CDMARCA: prodCot[i].CDMARCA,
				CDPRODESTO: prodCot[i].CDPRODESTO,
				CDPRODUTO: prodCot[i].CDPRODUTO,
				CODIGOMARC: prodCot[i].CODIGOMARC,
				CODIGOPROD: prodCot[i].CODIGOPROD,
				DSOBSRENEGOCIA: prodCot[i].DSOBSRENEGOCIA,
				IDITPEDPRIONEG: prodCot[i].IDITPEDPRIONEG,
				NOMEMARCA: prodCot[i].NOMEMARCA,
				NOMEPROD: prodCot[i].NOMEPROD,
				NRPEDIDOCOL: prodCot[i].NRPEDIDOCOL,
				PERCCONSISTENCIA: prodCot[i].PERCCONSISTENCIA,
				PERCVARIACAO: prodCot[i].PERCVARIACAO,
				PRECOOBJETIVO: prodCot[i].PRECOOBJETIVO,
				QTDISPPRODMARC: prodCot[i].QTDISPPRODMARC,
				QTSOMA: prodCot[i].QTSOMA,
				SGUNIDADE: prodCot[i].SGUNIDADE,
				VRPRECUNIPRMARC: prodCot[i].VRPRECUNIPRMARC,
				VRULTPRECPRMARC: prodCot[i].VRULTPRECPRMARC,
				__is_new : false
			};
			arrayProd.push(obj);
		}

		return restEngine.post('product#/crud/prmarcpedcol/save', {
			"requestType": "DataSet",
			"dataset": arrayProd
		});

	};

	this.validaReajuste = function(cdfilial, nrpedidocol, cdforneced, vrreajuste, vrreajuste2){

		return restEngine.post('/validaReajuste', {
			"requestType": "FilterData",
			"filter": [
				 {
				 	"name": "P_CDFILIAL",
				 	"operator": "=",
				 	"value":  cdfilial
				 },
				 {
				 	"name": "P_NRPEDIDOCOL",
				 	"operator": "=",
				 	"value":  nrpedidocol
				 },
				 {
				 	"name": "P_CDFORNECED",
				 	"operator": "=",
				 	"value":  cdforneced
				 },
				 {
				 	"name": "P_PERCREAJUSTE2",
				 	"operator": "=",
				 	"value":  vrreajuste
				 },
				 {
				 	"name": "NRORG",
				 	"operator": "=",
				 	"value":  getLocalVar('NRORGTRAB')
				 },
				 {
				 	"name": "P_VRREAJUSTE2",
				 	"operator": "=",
				 	"value":  vrreajuste2
				 }
			]
		});
	};

	this.totalNaoReajustado = function(cdfilial, nrpedidocol, cdforneced, vrreajuste){

		return restEngine.post('/totalNaoReajustado', {
			"requestType": "FilterData",
			"filter": [
				 {
				 	"name": "CDFILIAL",
				 	"operator": "=",
				 	"value":  cdfilial
				 },
				 {
				 	"name": "NRPEDIDOCOL",
				 	"operator": "=",
				 	"value":  nrpedidocol
				 },
				 {
				 	"name": "CDFORNECED",
				 	"operator": "=",
				 	"value":  cdforneced
				 },
				 {
				 	"name": "PERCREAJUSTE",
				 	"operator": "=",
				 	"value":  vrreajuste
				 },
				 {
				 	"name": "NRORG",
				 	"operator": "=",
				 	"value":  getLocalVar('NRORGTRAB')
				 }
			]
		});
	};


	this.proceAceitaPedCotWeb = function(cdfilial, nrpedidocol, idconsiste) {
        return restEngine.post('/proceAceitaPedCotWeb', {
            "requestType": "Row",
            "row": {
            	"CDFILIAL": cdfilial,
                "NRPEDIDOCOL": nrpedidocol,
                "IDCONSISTE": idconsiste
            }
        }, null, null, null, null, 99999);
    };

    this.atualizaPreco = function(produto) {

		return restEngine.post('product#/crud/prmarcpedcol/save', {
			"requestType": "Row",
			"row": {
	            "CDFILIAL": produto.CDFILIAL,
				"CDMARCA": produto.CDMARCA,
				"CDPRODESTO": produto.CDPRODESTO,
				"CDPRODUTO": produto.CDPRODUTO,
				"CODIGOMARC": produto.CODIGOMARC,
				"CODIGOPROD": produto.CODIGOPROD,
				"DSOBSRENEGOCIA": produto.DSOBSRENEGOCIA,
				"IDITPEDPRIONEG": produto.IDITPEDPRIONEG,
				"NOMEMARCA": produto.NOMEMARCA,
				"NOMEPROD": produto.NOMEPROD,
				"NRPEDIDOCOL": produto.NRPEDIDOCOL,
				"PERCCONSISTENCIA": produto.PERCCONSISTENCIA,
				"PERCVARIACAO": produto.PERCVARIACAO,
				"PRECOOBJETIVO": produto.PRECOOBJETIVO,
				"QTDISPPRODMARC": produto.QTDISPPRODMARC,
				"QTSOMA": produto.QTSOMA,
				"SGUNIDADE": produto.SGUNIDADE,
				"VRPRECUNIPRMARC": produto.VRPRECUNIPRMARC,
				"VRULTPRECPRMARC": produto.VRULTPRECPRMARC,
				"changed": true,
				"__is_new" : false
				}
		});
	};

	this.atualizaProdutoPedidoCotacao = function(data){

		return localStorageEngine.saveInServer('product#/crud/prmarcpedcol', null, data, 1, 60000);

	};

	this.validaAtualizacao = function(cdfilial, cdproduto, cdmarca, nrpedidocol){

		return restEngine.post('/validaAtualizacao', {
			"requestType": "FilterData",
			"filter": [
				 {
				 	"name": "P_CDFILIAL",
				 	"operator": "=",
				 	"value":  cdfilial
				 },
				 {
				 	"name": "P_CDPRODUTO",
				 	"operator": "=",
				 	"value":  cdproduto
				 },
				 {
				 	"name": "P_CDMARCA",
				 	"operator": "=",
				 	"value":  cdmarca
				 },
				 {
				 	"name": "P_NRPEDIDOCOL",
				 	"operator": "=",
				 	"value":  nrpedidocol
				 }		
			]
		});
	};

	this.validaItemPedidoCotocao = function(cdfilial, nrpedidocol){

		return restEngine.post('/itemPedidoCotocao', {
			"requestType": "FilterData",
			"filter": [
				 {
				 	"name": "CDFILIAL",
				 	"operator": "=",
				 	"value":  cdfilial
				 },
				 {
				 	"name": "NRPEDIDOCOL",
				 	"operator": "=",
				 	"value":  nrpedidocol
				 },
				 {
				 	"name": "NRORG",
				 	"operator": "=",
				 	"value": getLocalVar('NRORGTRAB')
				 }
			]
		});
	};

	this.atualizaItemPedCol = function(prodCot) {
		return restEngine.post('/itempedcol/save', {
			"requestType": "DataSet",
			"dataset": prodCot
		});

	};
	
	this.alterarHistnegociapcol = function(prodCot, dtini, dtfin) {
		var arrayProd = [];
		for(var i in prodCot) {
			if(prodCot[i].VRPRECREN     === undefined) prodCot[i].VRPRECREN     = null;
			if(prodCot[i].PRECOOBJETIVO === undefined) prodCot[i].PRECOOBJETIVO = null;
			var obj = {
				CDFILIAL:		 prodCot[i].CDFILIAL,
				NRPEDCOLETA:	 prodCot[i].NRPEDIDOCOL,
				DTINIVALITM:	 dtini,
				DTFINVALITM:	 dtfin,
				CDCOMPRADOR:	 getLocalVar('CDOPERADOR'),
				DSOBSRENEGOCIA:  prodCot[i].DSOBSRENEGOCIA,
				CDPRODUTO:		 prodCot[i].CDPRODUTO,
				CDMARCA:		 prodCot[i].CDMARCA,
				VRPRECUNIPRMARC: General.valueToFloat(prodCot[i].VRPRECUNIPRMARC),
				VRPRECREN:		 General.valueToFloat(prodCot[i].VRPRECREN),
				PROBJATUAL: 	 General.valueToFloat(prodCot[i].PRECOOBJETIVO),
				VRULTPRECPRMARC: General.valueToFloat(prodCot[i].VRULTPRECPRMARC),
				IDITPEDPRIONEG:  prodCot[i].IDITPEDPRIONEG,
				__is_new : false
			};
			arrayProd.push(obj);
		}
		return restEngine.post('/itempedcol/alterarHistnegociapcol', {
			"requestType": "DataSet",
			"dataset": arrayProd
		});
	};

	this.duplicaPedCot = function(cdfilial, nrpedidocol) {
        return restEngine.post('/duplicaPedCot', {
            "requestType": "Row",
            "row": {
            	"CDFILIAL": cdfilial,
                "NRPEDIDOCOL": nrpedidocol
            }
        }, null, null, null, null, 99999);
    };

    this.permissaoIncluirProduto = function () {
        return restEngine.post('/permissaoIncluirProd', {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "P_CDFORNECED",
                    "operator": "=",
                    "value": getLocalVar('CDFORNECED')
                },
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": getLocalVar('NRORGTRAB')
                }
            ]
        });
    };

	this.parasupri = function(cdfilial) {
		
		return restEngine.post('product#/crud/parasupri', {
			"requestType": "FilterData",
			"filter": [
				{
					"name": "CDFILIAL",
					"operator": "=",
					"value":  cdfilial
				}
			]
		});

	};    

	//this.produtoInclusao = function(idutlprodcmp) {
	//
	//	return restEngine.post('/produtoInclusao', {
	//		"requestType": "FilterData",
	//		"filter": [
	//			{
	//				"name": "P_CDFORNECED",
	//				"operator": "=",
	//				"value":  getLocalVar('CDFORNECED')
	//			},
	//			{
	//				"name": "P_IDUTLPROCMP",
	//				"operator": "=",
	//				"value":  idutlprodcmp
	//			}
	//		]
	//	});
    //
	//};

	this.marcaProduto = function(cdproduto, cdfilial, nrpedidocol) {
		
		return restEngine.post('/marcaProduto', {
			"requestType": "FilterData",
			"filter": [
				{
					"name": "P_CDPRODUTO",
					"operator": "=",
					"value":  cdproduto
				},
				{
					"name": "P_CDFILIAL",
					"operator": "=",
					"value":  cdfilial
				},
				{
					"name": "P_NRPEDIDOCOL",
					"operator": "=",
					"value":  nrpedidocol
				}
			]
		});

	}; 	

	this.incluirPrmarcpedcol = function(cdfilial, cdproduto, nrpeddocol, cdmarca) {
		
		var produto = [];

		var prod = {
			CDFILIAL: cdfilial,
			CDMARCA: cdmarca,
			CDPRODUTO: cdproduto,
			DSOBSRENEGOCIA: '',
			IDITPEDPRIONEG: 'N',
			NRPEDIDOCOL: nrpeddocol,
			QTDISPPRODMARC: '',
			VRPRECUNIPRMARC: '0',
			VRULTPRECPRMARC: '',
			IDPRODINCLFOR:   'S',
			__is_new : true
		};
		produto.push(prod);

		return restEngine.post('product#/crud/prmarcpedcol/save', {
			"requestType": "DataSet",
			"dataset": produto
		});

	};


	this.prmarcpedcol = function(cdfilial, nrpedidocol, cdproduto, cdmarca) {
		
		return restEngine.post('product#/crud/prmarcpedcol', {
			"requestType": "FilterData",
			"filter": [
				{
					"name": "CDFILIAL",
					"operator": "=",
					"value":  cdfilial
				},
				{
					"name": "NRPEDIDOCOL",
					"operator": "=",
					"value":  nrpedidocol
				},			
				{
					"name": "CDPRODUTO",
					"operator": "=",
					"value":  cdproduto
				},
				{
					"name": "CDMARCA",
					"operator": "=",
					"value":  cdmarca
				}				
			]
		});
	}; 	

	this.pedcoleta = function(cdfilial, nrpedidocol) {
		
		return restEngine.post('/pedcoleta', {
			"requestType": "FilterData",
			"filter": [
				{
					"name": "CDFILIAL",
					"operator": "=",
					"value":  cdfilial
				},
				{
					"name": "NRPEDIDOCOL",
					"operator": "=",
					"value":  nrpedidocol
				},			
				{
					"name": "CDFORNECED",
					"operator": "=",
					"value":  getLocalVar('CDFORNECED')
				}		
			]
		});
	}; 		

	this.incluirItemPedColeta = function(cdfilial, nrpedidocol, cdregiao, cdproduto, cdmarca, vritempedcol, vrantitpedcol){

		var produto = [];

		var prod = {
			CDFILIAL: cdfilial,
            NRPEDCOLETA: nrpedidocol,
            CDFORNECED: getLocalVar('CDFORNECED'),
            CDREGIAO: cdregiao,
            CDPRODUTO: cdproduto,
            CDMARCA: cdmarca,
            QTPRODPEDCOL: 0,
            VRITEMPEDCOL: vritempedcol,
            VRANTITPEDCOL: vrantitpedcol,
            IDSELELEILAO: '', 
            VRPRECECOPEDCOL: '', 
            VRPERDESPEDCOL: '', 
            VRPRECPIPEDCOL: '',
            DTULTATUITPCOL: '', 
            IDITEMPEDCOLALT: '', 
            IDPRECONPCOLATU: 'N',
            IDITPEDPRIONEG: 'N',
            DSOBSRENEGOCIA: '',
            __is_new : true
		};

		produto.push(prod);

		return restEngine.post('/itempedcol/save', {
			"requestType": "DataSet",
			"dataset": produto
		});

	};

	this.save = function (cdfilial, nrpedidocol, cdproduto, cdmarca) {

		var produto = [];

		var prod = {
			P_CDFILIAL: cdfilial,
            P_NRPEDCOLETA: nrpedidocol,
            P_CDPRODUTO: cdproduto,
            P_CDMARCA: cdmarca
		};

		produto.push(prod);
       	return restEngine.post("/insertItemPedCol/save",
				{
    	          	"requestType": "Row",
        	        "row": produto
				});
    };

	this.updatePrmarcpedcol = function(rowsValues){
		return restEngine.post('/updatePrmarcpedcol',{
            "requestType": "Row",
            "row": rowsValues
        }); 
	};
	
	this.updateItemPedidoCotacao = function(itemPedidoCotacao){
		return restEngine.post('/updateItemPedidoCotacao',{
            "requestType": "Row",
            "row": itemPedidoCotacao
        }); 
	};
	
	this.replicar = function(prodCot) {
		var arrayProd = [];
		
		for(var i in prodCot) {
			var obj = {
				CDFILIAL: prodCot[i].CDFILIAL,
				CDMARCA: prodCot[i].CDMARCA,
				CDPRODUTO: prodCot[i].CDPRODUTO,
				NRPEDIDOCOL: prodCot[i].NRPEDIDOCOL,
				VRPRECREN: prodCot[i].VRPRECREN,
				__is_new : false
			};
			arrayProd.push(obj);
		}

		return restEngine.post('product#/crud/prmarcpedcol/save', {
			"requestType": "DataSet",
			"dataset": arrayProd
		});

	};

};

Configuration(function(ContextRegister) {
	ContextRegister.register('PedidoCotacaoService', PedidoCotacaoService);
});
